import { config } from './config.js'
import fetch from 'node-fetch'

export async function getMergedMetadata () {
  const metadata = await Promise.all(config.urls.map(async url => {
    const { origin } = new URL(url)
    try {
      const response = await fetch(new URL('meta.json', origin))
      if (!response.ok) return
      return response.json()
    } catch (e) {
      // unhandled
    }
  }))
  metadata.push({
    id: 'manifest-service',
    name: 'Manifest Service',
    buildDate: process.env.BUILD_TIMESTAMP,
    commitSha: process.env.CI_COMMIT_SHA,
    version: process.env.APP_VERSION
  })
  // only return when contains data
  return metadata.filter(Boolean)
}
